#!/bin/sh
echo "Weird errors/crashes occur at module load time and or link time and need to be debugged before this is usable"
echo "/lib/modules/oss/build/install.sh does some weird fuckery like linking precompiled internal object files to the oss projcet to kernel object files and making it a module(s)"
echo "When compiling in kernel the kernel build system detects the shared object names that are duplicates and says fuck no to linking it. Simple fix would just be renaming the functions, for all of them under oss/lib/drv/ in the oss source, ugh."
echo " On linux-5.0.* it also fails in any capacity to export the function/symbols used for module parameters when using symbol trimming, built in kernel or with install.sh that is"
echo "just use the default ./lib/modules/oss/build/install.sh without symbol trimming for now till this is debugged more"

echo "You have ten second to stop this script from having to re install the kernel source directory under /usr/src/linux if you don't want oss in kernel testing, CTRL+C is your friend"
wait 10

echo "commencing copying of installed oss4 kernel sources to /usr/src/linux/sound/oss4/"
mkdir /usr/src/linux/sound/oss4
mkdir /usr/src/linux/sound/oss4/precompiled-includes
cp -fr /lib/modules/oss/build/* /usr/src/linux/sound/oss4/
cp -fr /lib/modules/oss/include/internals/* /usr/src/linux/sound/oss4/
cp -fr /lib/modules/oss/include/sys/* /usr/src/linux/sound/oss4/
cp -fr /lib/modules/oss/modules.regparm/* /usr/src/linux/sound/oss4/precompiled-includes/
cp -fr /lib/modules/oss/objects.regparm/* /usr/src/linux/sound/oss4/precompiled-includes/
cp Kconfig /usr/src/linux/sound/oss4/
cp Makefile /usr/src/linux/sound/oss4/
cp OSS-* /usr/src/linux/
cp inkernel.patch /usr/src/linux/
rm /usr/src/linux/sound/oss4/install.sh
rm /usr/src/linux/sound/oss4/WARNING.txt
rm /usr/src/linux/sound/oss4/Makefile.osscore
rm /usr/src/linux/sound/oss4/Makefile.tmpl
rm /usr/src/linux/sound/oss4/regparm
rm /usr/src/linux/sound/oss4/Module.symvers
echo "commencing patching for OSS4"
cd /usr/src/linux/
patch -p1 -i OSS-Kconfig.patch
patch -p1 -i OSS-makefile.patch
patch -p1 -i inkernel.patch
cd /usr/src/linux/sound/oss4/precompiled-includes/
echo "renaming pre-compiled object files from oss installation to kernel usable ones"
for file in *.o; do
    mv "$file" "$(basename "$file" .o)main.o_shipped"
done
cd /usr/src/linux/sound/oss4/
echo "rename autogenerated kernel source files to maintain legacy names in Makefile while not letting kbuild system have circular dependencies"
for file in *.c; do
    mv "$file" "$(basename "$file" .c)1.c"
done
echo "all done, go run menuconfig and or compile your modules now to debug"
